/*
 * Copyright (c) 2004 Chirok Han
 *
 * This file is part of fig2pstricks.
 *
 * Fig2pstricks is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Fig2pstricks is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with fig2pstricks; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * Contact: beanerjo@yahoo.com
 */

#include "fig2pstricks.h"
#include "symbol.h"
#include "extern.h"

char color_name_buf[32];
extern int global_depth;
extern int _debug;


char *end_of_string(char *str)
{
    char *p = str;
    int end = 0;
    while (!end && *p) {
	if (*p=='\\') {
	    p++;
	    if (*p>='0' && *p<='7') {
		if (*p=='0' && *(p+1)=='0' && *(p+2)=='1') end=1;
		p+=3;
	    } else {
		p++;
	    }
	} else {
	    p++;
	}
    }
    return p;
}


int preinfo_text(int*ctbl,int*xmin,int*ymin,int*xmax,int*ymax,STREAM*sp)
{
    int i, n, x0, y0, x1, y1, ht, wd, subtype, depth;
    char *p, *endptr;

    subtype = tscani(sp);
    into_colortbl(ctbl,tscani(sp)); // color
    depth = tscani(sp);
    tskipw(sp, 5);
    ht = (int)ceil(tscand(sp));
    wd = (int)ceil(tscand(sp));
    x0 = tscani(sp);
    y1 = tscani(sp);
    // skip string
    p = ttell(sp);
    sp->curpos = end_of_string(p);
    p++;

    if (strncmp(p, XFIG_SPECIAL, STRLEN_XFIG_SPECIAL)) { // if plain text
	if (subtype==1) x0 -= wd/2;
	else if (subtype==2) x0 -= wd;

	x1 = x0+wd;
	y0 = y1-ht;

	if (x0<*xmin) *xmin=x0;
	if (y0<*ymin) *ymin=y0;
	if (x1>*xmax) *xmax=x1;
	if (y1>*ymax) *ymax=y1;
    } else { // if xfig source special for depth setting
	p += STRLEN_XFIG_SPECIAL;
	if (!strncmp(p, XFIG_DEPTH, STRLEN_XFIG_DEPTH)) {
	    global_depth = atoi(p+STRLEN_XFIG_DEPTH);
	}
    }
    return depth;
}

void proc_text(FILE *fp, STREAM *sp) /* 4 */
{
    int nchg, color, hasset=0, justify, depth, height, font, x, y, c;
    double fontsize, angle;
    char *p, *endptr;
    STYLE style;

    justify = tscani(sp);
    color = tscani(sp);
    depth = tscani(sp);
    tskipw(sp, 1);
    font = tscani(sp);
    fontsize = tscand(sp);
    angle = tscand(sp);
    tskipw(sp, 1);
    height = (int)tscand(sp);
    tskipw(sp, 1);
    x = tscani(sp);
    y = tscani(sp);
    p = ttell(sp);
    p++;
    endptr = end_of_string(p)-4;
    tsetpos(sp, endptr+4);

    if (strncmp(p, XFIG_SPECIAL, STRLEN_XFIG_SPECIAL)) { // if plain text
	fprintf(fp, "\n\\rput");
	if (justify==0) fprintf(fp, "[l]");
	else if (justify==2) fprintf(fp, "[r]");
	if (fabs(angle)>0.000001) fprintf(fp, "{%.0f}", RAD2DEG(angle));
	fprint_xy(fp, x, y);

	fputc('{', fp);
	latex_color_command(fp, color);

	if (math_label || font==32) fprintf(fp, "$"); // font==32: symbol
	while (p<endptr) {
	    if (*p=='\\') {
		p++;
		if (*(p++)=='\\') {
		    fputc('\\', fp);
		} else {
		    c = 64*(*(p++)-'0');
		    c += 8*(*(p++)-'0');
		    c += *(p++)-'0';
		    fputc(c, fp);
		}
	    } else {
		if (font==32 && isalpha(*p)) {
		    if (strlen(symbol_table[*p])>0) {
			fprintf(fp, symbol_table[*p]);
			fputc(' ',fp);
		    } else {
			if (*p=='%') fputc('\\',fp);
			fputc(*p,fp);
		    }
		} else {
		    if (*p=='%') fputc('\\',fp);
		    fputc(*p, fp);
		}
		p++;
	    }
	}
	if (math_label || font==32) fputc('$', fp);
	fputc('}', fp);
    }
}
